using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GeometrischeMengen
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            Bitmap bmp = new Bitmap(ClientSize.Width, ClientSize.Height);

            const double linienDicke = 10.0;

            // sehr *in*effizientes Verfahren zum Zeichnen, aber mathematisch korrekt

            for (int y = 0; y < ClientSize.Height; y++)
            {
                for (int x = 0; x < ClientSize.Width; x++)
                {
                    // fette Gerade
                    double yC = -(ClientSize.Height - 1) / (double)(ClientSize.Width - 1) * x + ClientSize.Height - 1;
                    if (y >= yC - 0.5 * linienDicke && y <= yC + 0.5 * linienDicke)
                    {
                        bmp.SetPixel(x, y, Color.Blue);
                    }

                    // fensterfllende Kreisscheibe
                    double r = 0.5 * Math.Min(ClientSize.Width, ClientSize.Height);
                    double dx = x - 0.5 * (ClientSize.Width - 1);
                    double dy = y - 0.5 * (ClientSize.Height - 1);
                    if (dx * dx + dy * dy <= r * r)
                    {
                        bmp.SetPixel(x, y, Color.Red);
                    }
                }
            }

            e.Graphics.DrawImage(bmp, 0, 0);
        }

        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);

            Invalidate();
        }
    }
}